#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
/*
 * Denpa Jack(denpa.c)--Osaka-ben converter extended filter.
 *   by http://www7b.biglobe.ne.jp/~bprince/hr/parker/
 *
 * []
 *   denpa - ٕϊgtB^[
 *
 * []
 *   denpa [-b] [-r] [-t/-T] [-s] [-h] [-999] [-v] [-u] [-o] [-f dict-file] [input-file]
 *
 * []
 *  "Denpa Jack" ٕ͑ϊtB^[Ƀ_u@\ĝłB
 *   W͂ϊĕWo͂ɓfo܂B
 *       1) cat source.txt | denpa -f denpa.dic > kekka.txt
 *       2) cat source.htm | denpa -b -f denpa.dic > kekka.html
 *       3) cat source.htm | denpa -b -r -t -f denpa.dic > kekka.html
 *   ϊ͊Ot@C̈ȉ̗`łB^u͖YꂸɁI
 *       ϊO[TAB]ϊ㕶[CR]
 *       ϊO[TAB]ϊ㕶[CR]
 *       ϊO[TAB]ϊ㕶[CR]
 *   ^CgUꍇ́ARp[^KvłB
 *       ϊO[TAB]ϊ㕶[TAB]^Cg[CR]
 *       ϊO[TAB]ϊ㕶[TAB]^Cg[CR]
 *       ϊO[TAB]ϊ㕶[TAB]^Cg[CR]
 *   ϊSORTĂKv͂܂񂪁ASORTĂN͂ɑB
 *   HTML̃^O郍WbNgݍł܂B
 *       ^O邱ƂŃAt@xbg̕ϊ\ɂȂ܂B
 *     î܂ܕϊƃ^Ȍ܂ŏĂ܂ꍇ邽߁j
 *       ^O邱Ƃ<b></b>^Ow肷邱Ƃł܂B
 *     iႦ΁A<title>```</title>̃^Oł͕ῗ܂<b>^O</b>͕t^܂j
 *   ϊO̕񂪓̏ꍇ_ɒu\łB
 *       )
 *       łB[tab]łB[CR]
 *       łB[tab]łˁB[CR]     ̂ꂩ_ɒu
 *       łB[tab]łB[CR]
 *
 * [t@C]
 *   /usr/share/dict/denpa.dic
 *       denpa-jack
 *
 * [IvV]
 *  -b : ϊ<b>{[h</b>ŊBϊꍇfobO̍ۂɕ֗B
 *  -r : ϊ<ruby>r</ruby>ŊBrɐÛ͕ϊOB
 *  -t : ϊ<font TITLE="^Cg"></font>ŊB
 *       ^CgɐÛ͕ΐu^CgvB
 *  -T : ϊ<font TITLE="^Cg(ϊO)"></font>ŊB
 *       ^CgɐÛ͕ΐu^Cg(ϊO)vB
 *  -s : SORTςݎgB\[gsȂB
 *  -h : HTMLBHTML^O`ŕϊ܂(ȕ֓IȕsSł)B
 *  -999 : 999͎̔Cӂ̍ڐ(1`n)Bf[^Qxǂ݂ȂB
 *       ۂ傫ȒlłΌłȂĂ悢B菬n܂łWJB
 *  -v : o[Wo͂܂B̃IvVw肵͕ϊ͍s܂B
 *  -u : j[NwB̌ɑlgă_EV[h܂B
 *  -d : ϐ"DENPA"玫t@C擾܂B
 *  -o : ϐ"OKASAN"玫t@C擾܂B
 *  -n : ϐ"NIHON"玫t@C擾܂B
 *  -k : ϐ"OSAKA"玫t@C擾܂B
 *  -f : t@C̎wBw肪Ȃ΃JgfBNgɑ݂"denpa.dic"B
 *
 * [RpC]
 *   cc [optimization] denpa.c -o denpa
 *
 *
 * [CZX]
 *   GPLɏt[\tgEFAƂĔzz܂
 *   (http://www.gnu.org/copyleft/gpl.html)Q
 *
 * [⑫]
 *   "Denpa Jack" ̂HTML擾GW𓋍ڂĂ܂BPȂtB^[
 *   łB̂߃z[y[W̕ϊCGI𐧍삷ꍇAHTML擾GWʓr
 *   KvłB
 *       Perl CGI̍\z@ɂẮuxṽy[WQlɂƂ悢
 *       傤B
 *           http://www.ash.or.jp/~take/osaka/
 *       DelegategvLVoRϊ̍\źuYanṽy[WQl
 *       Ȃ܂B
 *           http://www6.plala.or.jp/yan2/
 *
 * [mF]
 *   Windows XP SP3
 *   Windows 2000 Professional/Server SP4
 *   Windows NT Ver 3.51/4.0
 *   MS-DOS ver 3.3
 *   AIX Version 4.3(IBM RS/6000)
 *   SunOS 5.8(SunMicrosystems SUN4U SPARC)
 *   Linux 2.2.12(Red Had 6.1J)
 *
 * [XV]
 *   2000/03/21 v1.00 osaka.cQlɂđSʓIɏ
 *   2000/07/24 v1.01 rU@\ǉ
 *   2000/07/28 v1.02 ^CgU@\ǉ
 *   2000/08/15 v1.03 hLg኱
 *   2000/09/01 v1.04 ^CgɕϊOU@\ǉ
 *   2000/09/12 v1.05 <nofilter>^OΉA^OŊƕϊΏۊOƂȂ܂
 *   2000/09/26 v1.06 ϊԐFɕϊ@\ǉ(v1.07ŋ@\폜)
 *   2001/08/31 v1.07 œǨASORTςݎƒPꐔ̏lw̋@\ǉ
 *   2001/09/04 v1.08 t@CϐŎwo悤ύX
 *   2001/09/05 v1.09 ̓t@Cwo悤ύX
 *   2001/09/06 v1.10 o̓t@Cwo悤ύX(v1.16ŋ@\폜)
 *   2001/09/10 v1.11 stringn֐memoryn֐ɒu
 *   2002/02/15 v1.12 o[W\Aϐ"OSAKA"ɑΉA񕪌̃oNC
 *   2002/08/15 v1.13 t@Cw肳ĂȂƂ̑Ήǉ
 *   2003/03/03 v1.14 WIN32̑Ή
 *   2003/03/19 v1.15 ̓ftHgHTML`WTEXT`ɕύX
 *   2004/02/18 v1.16 ̓̓t@Cϊł悤ύX
 *   1784/02/23 v1.17 ϓz𔭌
 *   2004/07/27 v1.18 ̃\[gWSORT֐uCOMBSORTvɕύX
 *   2005/01/11 v1.19 ̎wɑΉ
 *   2005/03/11 v1.20 ϐ"NIHON"ɑΉ
 *   2011/01/28 v1.21 ʊ֐̃G[̌㏈
 */

#ifdef WIN32
#define strncasecmp strnicmp
#define RAND
#define SJIS
#endif
#ifdef SJIS
#define isKANJIb(c) ((unsigned char)((c^0x20)-0xA1)<=0x3B) 
#else
#define isKANJIb(c) (c&0x80)
#endif

#define DEF_INPBUF_LEN (1024*16) /* ̓obt@ */
#define DEF_OUTBUF_LEN (1024*32) /* o̓obt@ */

typedef unsigned char mchar;
typedef struct st_word /* ̒` */
{
    struct st_dict *dict;
    mchar  *inp_str;
    int     inp_len;
    mchar  *out_str;
    int     out_len;
    mchar  *opt_str;
    int     opt_len;
    int     cnt;
    int     tail_pos;
    mchar   tail_byte;
}   ST_WORD;     
typedef struct st_dict /* ̒` */
{
    char    *path;
    char    *comment;
    int     word_cnt;
    ST_WORD *word_tbl;
    int     word_idx[256+1];
    int     word_len[256];
}   ST_DICT;

static char *setdict(char p_env_nm[], char p_file_nm[]);
static ST_DICT *mergedict(ST_DICT *p_dict_tbl[], int p_dict_cnt);
static ST_DICT *loaddict(char p_file_nm[]);
static int line_count(char p_file_nm[]);
static int combsort(char *p_word, int p_cnt, int p_size,
       int (*fx_compare)(char *p_word_a, char *p_word_b));
static int qsort_compare(const char *p_word_a, const char *p_word_b);
static int indexing(ST_DICT *p_dict);
static int convert(FILE *p_file);
static int convert_html(mchar p_out_str[], mchar p_inp_str[], int p_inp_len);
static int convert_text(mchar p_out_str[], mchar p_inp_str[], int p_inp_len);
static ST_WORD *getword(ST_DICT *p_dict, mchar p_str[]);

char       *kd_ver      = "1.21";        /* o[W */
char       *kd_usage    = "usage: denpa [option]... [filename]...\n";

FILE       *kd_file     = NULL;          /* ̓t@C */
int         kd_bold     = 0;             /* 邩 */
int         kd_ruby     = 0;             /* rU邩 */
int         kd_title    = 0;             /* ^CgU邩 */
int         kd_colour   = 0;             /* Ft */
int         kd_sort     = 0;             /* \[gς */
int         kd_html     = 0;             /* ϊ */
int         kd_uniq     =-1;             /* _EV[h */
int         kd_word_cnt = 0;             /* f[^̃JE^ */

mchar      *kd_inp_str  = NULL;          /* ̓obt@ */
mchar      *kd_out_str  = NULL;          /* o̓obt@ */

char       *kd_dict_path= NULL;          /* t@C */
ST_DICT    *kd_dict     = NULL;          /*  */
int         kd_dict_cnt = 0;             /*  */
ST_DICT   **kd_dict_tbl = NULL;          /* Xg */

/***
 * C
 ***/
int main(int argc, char *argv[])
{
    int     i, j;
    int     ret;

    /* NIvV̔ */
    kd_dict_cnt = 0;
    kd_dict_tbl = malloc(argc*sizeof(ST_DICT*));
    if (kd_dict_tbl == NULL)
    {
        perror ("malloc");
        return (-1);
    }

    kd_file=stdin;
    for(i=1; i<argc; i++)
    {
        if (argv[i][0]=='-')
        {
            switch(argv[i][1])
            {
            case 'b':
                kd_bold=1;
                continue;

            case 'r':
                kd_ruby=1;
                continue;

            case 't':
                kd_title=1;
                continue;

            case 'T':
                kd_title=2;
                continue;

#ifdef COLOURED
            case 'c':
                kd_colour=1;
                continue;
#endif

            case 's':
                kd_sort=1;
                continue;

            case 'h':
                kd_html=1;
                continue;

            case 'v':
                fprintf(stderr, "Denpa-Jack version %s\n", kd_ver);
                return(0);

            case 'u':
                if (isdigit(argv[i][2])) /* -u999 */
                {
                    kd_uniq = strtol(&argv[i][2], NULL, 10);
                    continue;
                }
                fprintf(stderr, kd_usage);
                return(-1);

            case 'd':
            case 'o':
            case 'n':
            case 'k':
                for(j=1; argv[i][j]!=0x00; j++)
                {
                    switch(argv[i][j])
                    {
                    case 'd':
                        kd_dict_path = setdict("DENPA", "/usr/share/dict/denpa.dic");
                        kd_dict_tbl[kd_dict_cnt]=loaddict(kd_dict_path);
                        if (kd_dict_tbl[kd_dict_cnt]==NULL)
                        {
                            return(-1);
                        }
                        kd_dict_cnt++;
                        continue;

                    case 'o':
                        kd_dict_path = setdict("OKASAN", "/usr/share/dict/okasan.dic");
                        kd_dict_tbl[kd_dict_cnt]=loaddict(kd_dict_path);
                        if (kd_dict_tbl[kd_dict_cnt]==NULL)
                        {
                            return(-1);
                        }
                        kd_dict_cnt++;
                        continue;

                    case 'n':
                        kd_dict_path = setdict("NIHON", "/usr/share/dict/nihon.dic");
                        kd_dict_tbl[kd_dict_cnt]=loaddict(kd_dict_path);
                        if (kd_dict_tbl[kd_dict_cnt]==NULL)
                        {
                            return(-1);
                        }
                        kd_dict_cnt++;
                        continue;

                    case 'k': /* not osaka, but kansai */
                        kd_dict_path = setdict("OSAKA", "/usr/share/dict/osaka.dic");
                        kd_dict_tbl[kd_dict_cnt]=loaddict(kd_dict_path);
                        if (kd_dict_tbl[kd_dict_cnt]==NULL)
                        {
                            return(-1);
                        }
                        kd_dict_cnt++;
                        continue;
                    }
                    fprintf(stderr, kd_usage);
                    return(-1);
                }
                continue;

            case 'f':
                kd_dict_path = argv[i+1];
                if (kd_dict_path==NULL)
                {
                    fprintf(stderr, kd_usage);
                    return(-1);
                }
                kd_dict_tbl[kd_dict_cnt]=loaddict(kd_dict_path);
                if (kd_dict_tbl[kd_dict_cnt]==NULL)
                {
                    return(-1);
                }
                kd_dict_cnt++;
                i++;
                continue;

            default:
                if (isdigit(argv[i][1])) /* -999 */
                {
                    kd_word_cnt = strtol(&argv[i][1], NULL, 10);
                    continue;
                }
                fprintf(stderr, kd_usage);
                return(-1);
            }
        }
        kd_file = NULL;
    }

    /* t@Cw肳ĂȂꍇ */
    if (kd_dict_cnt==0)
    {
        /* ϐ玫t@C̎擾 */
        kd_dict_path = setdict("DENPA", "/usr/share/dict/denpa.dic");

        /* t@C̓ǂݍ */
        kd_dict = loaddict(kd_dict_path);
        if (kd_dict==NULL)
        {
            return(-1);
        }
    }
    else if (kd_dict_cnt==1) /* t@C1 */
    {
        kd_dict = kd_dict_tbl[0];
    }
    else /* t@C */
    {
        kd_dict = mergedict(kd_dict_tbl, kd_dict_cnt);
    }

    /* ̃CfbNX */
    indexing(kd_dict);

    /* ̊蓖 */
    kd_inp_str = malloc(DEF_INPBUF_LEN);
    if (kd_inp_str==NULL)
    {
        perror("malloc");
        return(-1);
    }

    kd_out_str = malloc(DEF_OUTBUF_LEN);
    if (kd_out_str==NULL)
    {
        perror("malloc");
        return(-1);
    }

    if (setvbuf(stdout, kd_out_str, _IOFBF, DEF_INPBUF_LEN)!=0)
    {
        perror("setvbuf");
        return(-1);
    }

    /* ̏ */
    if (kd_uniq<0)
    {
#ifdef RAND
        srand((unsigned)time(NULL));
#else
        srandom((unsigned)time(NULL));
#endif
    }
    else
    {
#ifdef RAND
        srand((unsigned)kd_uniq);
#else
        srandom((unsigned)kd_uniq);
#endif
    }

    /* ϊC */
    if (kd_file==stdin)
    {
        if (setvbuf(kd_file, kd_inp_str, _IOFBF, DEF_INPBUF_LEN)!=0)
        {
            perror("setvbuf");
            return(-1);
        }

        ret = convert(kd_file);
        if (ret<0)
        {
            return(-1);
        }
    }
    for(i=1; i<argc; i++)
    {
        if (argv[i][0]=='-')
        {
            switch(argv[i][1])
            {
                case 'f': i++; break;
            }
            continue;
        }

        kd_file = fopen(argv[i], "r");
        if (kd_file==NULL)
        {
            fprintf(stderr, "%s: No such file or directory\n", argv[i]);
            continue;
        }

        if (setvbuf(kd_file, kd_inp_str, _IOFBF, DEF_INPBUF_LEN)!=0)
        {
            perror("setvbuf");
            return(-1);
        }

        ret = convert(kd_file);
        if (ret<0)
        {
            return(-1);
        }

        fclose(kd_file);
    }
    fflush(stdout);
    return(0);
}

/* t@C̐ݒ */
char *setdict(char p_env_nm[], char p_file_nm[])
{
    char   *w_dict_nm;

    /* ϐ擾 */
    w_dict_nm = getenv(p_env_nm);
    if (w_dict_nm==NULL)
    {
        /* NꂽfBNg玫t@C쐬 */
#ifdef WIN32
        w_dict_nm = malloc(strlen(p_file_nm)+3);
        if (w_dict_nm == NULL)
        {
            perror("malloc");
            return (NULL);
        }
        strcpy(w_dict_nm, "c:");
        strcat(w_dict_nm, p_file_nm);
#else
        w_dict_nm=p_file_nm;
#endif
    }

    return(w_dict_nm);
}
/* ̗Z */
ST_DICT *mergedict(ST_DICT *p_dict_tbl[], int p_dict_cnt)
{
    int     i;
    int     w_word_cnt;
    ST_DICT *w_dict;

    /* ̃JEg */
    w_word_cnt=0;
    for(i=0; i<p_dict_cnt; i++)
    {
        w_word_cnt+=p_dict_tbl[i]->word_cnt;
    }

    /* ̃t */
    w_dict = (ST_DICT *)malloc(sizeof(ST_DICT)+(w_word_cnt*sizeof(ST_WORD)));
    if (w_dict==NULL)
    {
        perror("malloc");
        return(NULL);
    }
    memset(w_dict, 0x00, sizeof(ST_DICT));
    w_dict->path = "ST_DICT *mergedict(ST_DICT *p_dict_tbl[], int p_dict_cnt)";
    w_dict->word_tbl = (ST_WORD *)&w_dict[1];

    /* t@C̓WJ */
    w_word_cnt=0;
    for(i=0; i<p_dict_cnt; i++)
    {
        memcpy(&w_dict->word_tbl[w_word_cnt], p_dict_tbl[i]->word_tbl, sizeof(ST_WORD) * p_dict_tbl[i]->word_cnt);
        w_word_cnt+=p_dict_tbl[i]->word_cnt;
    }

    /* ̃JE^̐ݒ */
    w_dict->word_cnt=w_word_cnt;
    if (w_dict->word_cnt==0)
    {
        return(w_dict);
    }

    /* ̃\[g */
#ifdef QSORT
    qsort(w_dict->word_tbl, w_dict->word_cnt, sizeof(ST_WORD), qsort_compare);
#else
    combsort((char *)w_dict->word_tbl, w_dict->word_cnt, sizeof(ST_WORD), qsort_compare);
#endif

    return(w_dict);
}

/* t@C̓WJ */
ST_DICT *loaddict(char p_file_nm[])
{
    int     i, j, k;
    int     w_len;
    int     w_lens;

    FILE   *w_file;
    int     w_word_cnt;
    mchar   w_str[1024];
    mchar  *w_dup;
    ST_DICT *w_dict;
    ST_WORD *w_word;

    /* ̃JEgibj */
    if (kd_word_cnt==0)
    {
        w_word_cnt = line_count(p_file_nm);
    }
    else
    {
        w_word_cnt = kd_word_cnt;
    }
    if (w_word_cnt<0)
    {
        fprintf(stderr, "denpa: %s: No such file or directory\n", p_file_nm);
        return(NULL);
    }

    /* ̃t */
    w_dict = (ST_DICT *)malloc(sizeof(ST_DICT) + w_word_cnt * sizeof(ST_WORD));
    if (w_dict==NULL)
    {
        perror("malloc");
        return(NULL);
    }
    memset(w_dict, 0x00, sizeof(ST_DICT));
    w_dict->path     = strdup(p_file_nm);
    w_dict->comment  = NULL;
    w_dict->word_tbl = (ST_WORD *)&w_dict[1];

    /* t@C̃I[v */
    w_file = fopen(p_file_nm, "r");
    if (w_file==NULL)
    {
        fprintf(stderr, "denpa: %s: No such file or directory\n", p_file_nm);
        return(NULL);
    }

    /* t@C̓WJ */
    for(i=0; i<w_word_cnt; )
    {
        /* f[^̓ǂݍ */
        if (fgets(w_str, sizeof(w_str), w_file)==NULL) break;
        if (w_str[0]=='#')
        {
#ifdef COMMENTOUT
            if (i==0 && w_dict->comment==NULL)
            {
                w_str[strlen(w_str)-1]=0x00;
                j=1;
                //j+=strskip(&w_str[j]);
                w_dict->comment=strdup(&w_str[j]);
            }
#endif
            continue;
        }

        /* f[^̕ҏW */
        w_lens = strlen(w_str);
        w_len  = w_lens - 1;
        w_str[w_len]=0x00;

        for(j=1; j<w_len; j++)
        {
            if (w_str[j]=='\t')
            {
                w_str[j]=0x00;
                w_dup = malloc(w_lens);
                if (w_dup == NULL)
                {
                    perror ("malloc");
                    return (NULL);
                }
                memcpy(w_dup, w_str, w_lens);

                w_word = &w_dict->word_tbl[i];
                w_word->dict      = w_dict;
                w_word->inp_str   = w_dup;
                w_word->inp_len   = j;
                w_word->tail_byte = w_dup[ w_word->tail_pos = j - 1 ];
                w_word->opt_str   = NULL;
                /*w_word->opt_len = 0;*/

                j++;
                for(k=j; k<w_len; k++)
                {
                    if (w_dup[k]=='\t')
                    {
                        w_dup[k]=0x00;
                        w_word->opt_str = &w_dup[k+1];
                        w_word->opt_len = w_len-k-1;
                        break;
                    }
                }
                w_word->out_str = &w_dup[j];
                w_word->out_len = k-j;
              /*w_word->cnt     = 0;*/

                j=-1;
                break;
            }
        }
        if (j>0)
        {
            fprintf(stderr, ">> %s\n", w_str);
            continue;
        }
        i++;
    }
    fclose(w_file);

    /* ̃JE^̐ݒ */
    w_dict->word_cnt = i;
    if (w_dict->word_cnt==0)
    {
        return(w_dict);
    }

    /* ̃\[g */
    if (kd_sort==0)
    {
#ifdef QSORT
        qsort(w_dict->word_tbl, w_dict->word_cnt, sizeof(ST_WORD), qsort_compare);
#else
        combsort((char *)w_dict->word_tbl, w_dict->word_cnt, sizeof(ST_WORD), qsort_compare);
#endif
    }

    return(w_dict);
}

/* ̃JEg */
int line_count(char p_file_nm[])
{
    FILE   *w_file;
    int     w_cnt;
    mchar   w_str[1024];

    w_file = fopen(p_file_nm, "r");
    if (w_file==NULL)
    {
        return(-1);
    }

    for(w_cnt=0; ; w_cnt++)
    {
        if (fgets(w_str, sizeof(w_str), w_file)==NULL) break;
    }
    fclose(w_file);

    return(w_cnt);
}

/* R\[g */
int combsort(char *p_word, int p_cnt, int p_size,
    int (*fx_compare)(char *p_word_a, char *p_word_b))
{
    unsigned int i;
    int     sw;
    char   *w_word_a, *w_word_b; /* (A)(B) */
    char   *w_word_e, *w_word_t; /* (END)(TEMP) */

    w_word_t = malloc(p_size);
    if (w_word_t==NULL)
    {
        return(-1);
    }
    w_word_e = &p_word[(unsigned int)p_cnt * p_size];

    for(sw=1, i=p_cnt; i>1 || !sw; )
    {
        i=(i * 10 + 3) / 13;
        if (i==0)
        {
            i=1;
        }
        else if (i==9 || i==10)
        {
            i=11;
        }

        sw=1;
        for(w_word_a = p_word, w_word_b = &w_word_a[i * p_size];
            w_word_b < w_word_e;
            w_word_a+= p_size, w_word_b = &w_word_a[i * p_size])
        {
            if (fx_compare(w_word_a, w_word_b)>0)
            {
                memcpy(w_word_t, w_word_a, p_size);
                memcpy(w_word_a, w_word_b, p_size);
                memcpy(w_word_b, w_word_t, p_size);
                sw=0;
            }
        }
    }
    free(w_word_t);
    return(0);
}

/* ̃\[g */
int qsort_compare(const char *p_word_a, const char *p_word_b)
{
    ST_WORD *w_word_a = (ST_WORD *)p_word_a;
    ST_WORD *w_word_b = (ST_WORD *)p_word_b;

    if (*w_word_a->inp_str==*w_word_b->inp_str)
    {
        return(strcmp(w_word_a->inp_str, w_word_b->inp_str));
    }
    else
    {
        return(*w_word_a->inp_str - *w_word_b->inp_str);
    }
}

/* ̃CfbNX */
int indexing(ST_DICT *p_dict)
{
    int     i, j;
    int     w_byte, w_len;
    int     w_to;
    ST_WORD *w_word_tbl=p_dict->word_tbl;

    if (p_dict->word_cnt==0) {
        return(0);
    }

    /* CfbNX쐬 */
    w_len  = w_word_tbl[0].inp_len;
    w_byte = w_word_tbl[0].inp_str[0];

    for(i=1; i<p_dict->word_cnt; i++)
    {
        w_byte = w_word_tbl[i].inp_str[0];
        if (w_word_tbl[i-1].inp_str[0]!=w_byte)
        {
            p_dict->word_idx[ w_byte                     ] = i;
            p_dict->word_len[ w_word_tbl[i-1].inp_str[0] ] = w_len;
            w_len=w_word_tbl[i].inp_len;
            continue;
        }

        if (w_len > w_word_tbl[i].inp_len)
        {
            w_len = w_word_tbl[i].inp_len;
        }
    }
    p_dict->word_idx[256]=p_dict->word_cnt;
    p_dict->word_len[w_byte]=w_len;

    /* CfbNXĂȂ̃g~O */
    w_to = w_word_tbl[0].inp_str[0];
    for(i=255; i>w_to; i--)
    {
        if (p_dict->word_idx[i]==0)
        {
            p_dict->word_idx[i] = p_dict->word_idx[i+1];
        }
    }

    /* ϊǑ傪̂O[v */
    j=1;
    w_word_tbl[0].cnt=1;
    for(i=1; i<p_dict->word_cnt; i++)
    {
        if (w_word_tbl[i-1].inp_len==w_word_tbl[i].inp_len
        &&  memcmp(w_word_tbl[i-1].inp_str, w_word_tbl[i].inp_str, w_word_tbl[i].inp_len)==0)
        {
            j++;
            w_word_tbl[i].cnt=j;
        }
        else
        {
            j=1;
            w_word_tbl[i].cnt=1;
        }
    }

    return(0);
}

/***
 * ϊ
 **/

/* ̋ɋ܂̈NULLȂϊΏۊOAȊO<b>^O͉Ȃ */
/* Dx͉ɍsقǍ */
mchar  *kd_form_tbl[] = 
{
    "<title"    , "</title"    , "*",
    "<script"   , "</script"   , "*",
    "<textarea" , "</textarea" , "*",
    "<!-"       , "->"         , "*",
    "<"         , ">"          , NULL,
    "ALT=\""    , "\""         , "*",
    "VALUE=\""  , "\""         , "*",
    "TITLE=\""  , "\""         , "*",
    "<nofilter" , "</nofilter" , NULL,
     NULL       , NULL         , NULL,
};
int     kd_form_cnt;
int     kd_form_sw[128];
int     kd_form_len[128];

/* ϊC */
int convert(FILE *p_file)
{
    int     i, j, k;

    mchar   w_inp_str[DEF_INPBUF_LEN];
    mchar   w_out_str[DEF_OUTBUF_LEN];
    int     w_inp_len;
    int     w_out_len;

    mchar   w_str[DEF_INPBUF_LEN];
    int     w_prev, w_next;
    int     w_form_len;

    /* ϊw̏ꍇ */
    if (kd_html==0)
    {
        for(;;)
        {
            if (fgets(w_inp_str, sizeof(w_inp_str), p_file)==NULL) break;
            w_out_len = convert_text(w_out_str, w_inp_str, strlen(w_inp_str));
            fwrite(w_out_str, w_out_len, 1, stdout);
        }
        return(0);
    }

    /* e[ȕ */
    for(i=0; ; i++)
    {
        if (kd_form_tbl[i]==NULL)
        {
            if ((i%3)==0)
            {
                break;
            }
            continue;
        }
        kd_form_len[i]=strlen(kd_form_tbl[i]);
    }
    kd_form_cnt = i;
    memset(kd_form_sw, 0x00, sizeof(kd_form_sw));

    /* ϊ */
    w_prev=0;
    w_next=0;
    for(;;)
    {
        if (fgets(w_inp_str, sizeof(w_inp_str), p_file)==NULL) break;

        w_inp_len = strlen(w_inp_str);
        for(i=0, k=0; i<w_inp_len; )
        {
            w_prev=w_next;
            if (!isKANJIb(w_inp_str[i]))
            {
                w_form_len=0;
                w_next=0;
                for(j=0; j<kd_form_cnt; j+=3)
                {
                    if (strncasecmp(&w_inp_str[i], kd_form_tbl[j], kd_form_len[j])==0)
                    {
                        if (kd_form_tbl[j+2]!=NULL)
                        {
                            kd_form_sw[j]=1;
                            w_next=1;
                        }
                        else
                        {
                            kd_form_sw[j]=2;
                            w_next=2;
                        }
                        if (w_form_len==0)
                        {
                            w_form_len=kd_form_len[j];
                        }
                        continue;
                    }

                    if (strncasecmp(&w_inp_str[i], kd_form_tbl[j+1], kd_form_len[j+1])==0)
                    {
                        kd_form_sw[j]=0;
                        w_form_len=1;
                        continue;
                    }

                    /* Ō̏ԂLɂ */
                    if (kd_form_sw[j]==1)
                    {
                        w_next = 1;
                        continue;
                    }
                    if (kd_form_sw[j]==2)
                    {
                        w_next = 2;
                        continue;
                    }
                }

                if (w_form_len>0)
                {
                    if (k>0)
                    {
                        w_str[k]=0x00;
                        switch(w_prev)
                        {
                        case 0:
                            w_out_len = convert_html(w_out_str, w_str, k);
                            fwrite(w_out_str, w_out_len, 1, stdout);
                            break;
                        case 1:
                            w_out_len = convert_text(w_out_str, w_str, k);
                            fwrite(w_out_str, w_out_len, 1, stdout);
                            break;
                        default:
                            fwrite(w_str, k, 1, stdout);
                            break;
                        }
                        k=0;
                    }
                    fwrite(&w_inp_str[i], w_form_len, 1, stdout);
                    i+=w_form_len;
                    continue;
                }
            }

            if (isKANJIb(w_inp_str[i]))
            {
                memcpy(&w_str[k], &w_inp_str[i], 2);
                k+=2;
                i+=2;
            }
            else
            {
                memcpy(&w_str[k], &w_inp_str[i], 1);
                k++;
                i++;
            }
        }

        if (k>0)
        {
            w_str[k]=0x00;
            switch(w_prev)
            {
            case 0:
                w_out_len = convert_html(w_out_str, w_str, k);
                fwrite(w_out_str, w_out_len, 1, stdout);
                break;
            case 1:
                w_out_len = convert_text(w_out_str, w_str, k);
                fwrite(w_out_str, w_out_len, 1, stdout);
                break;
            default:
                fwrite(w_str, k, 1, stdout);
                break;
            }
            k=0;
        }
    }
    return(0);
}

/* HTMLϊ */
int convert_html(mchar p_out_str[], mchar p_inp_str[], int p_inp_len)
{
    int     i, j;
    ST_WORD *w_word;

    for(i=0, j=0; i<p_inp_len; )
    {
        /* ɂΕϊ */
        w_word = getword(kd_dict, &p_inp_str[i]);
        if (w_word!=NULL)
        {
            /* ϊOƕϊオꍇ͂̂܂ */
            if (w_word->inp_len == w_word->out_len
            &&  memcmp(w_word->inp_str, w_word->out_str, w_word->inp_len)==0)
            {
                memcpy(&p_out_str[j], w_word->out_str, w_word->out_len);
                i+=w_word->inp_len;
                j+=w_word->out_len;
                continue;
            }
            else
            {
#ifdef COLOURED
                if (kd_colour!=0)
                {
                    memcpy(&p_out_str[j], "<font COLOR=\"RED\">", 18); j+=18;
                }
#endif
                if (kd_ruby!=0)
                {
                    memcpy(&p_out_str[j], "<ruby><rb>", 10); j+=10;
                }

                if (kd_title!=0 && w_word->opt_str!=NULL)
                {
                    memcpy(&p_out_str[j], "<font TITLE=\"", 13); j+=13;
                    memcpy(&p_out_str[j], w_word->opt_str, w_word->opt_len); j+=w_word->opt_len;
                    if (kd_title==2)
                    {
                        memcpy(&p_out_str[j], "(", 1); j++;
                        memcpy(&p_out_str[j], w_word->inp_str, w_word->inp_len); j+=w_word->inp_len;
                        memcpy(&p_out_str[j], ")", 1); j++;
                    }
                    memcpy(&p_out_str[j], "\">", 2); j+=2;
                }

                if (kd_bold!=0)
                {
                    memcpy(&p_out_str[j], "<b>", 3); j+=3;
                }

                memcpy(&p_out_str[j], w_word->out_str, w_word->out_len);
                i+=w_word->inp_len;
                j+=w_word->out_len;

                if (kd_bold!=0)
                {
                    memcpy(&p_out_str[j], "</b>", 4); j+=4;
                }

                if (kd_title!=0 && w_word->opt_str!=NULL)
                {
                    memcpy(&p_out_str[j], "</font>", 7); j+=7;
                }

                if (kd_ruby!=0)
                {
                    memcpy(&p_out_str[j], "</rb><rp>(</rp><rt>", 19); j+=19;
                    memcpy(&p_out_str[j], w_word->inp_str, w_word->inp_len); j+=w_word->inp_len;
                    memcpy(&p_out_str[j], "</rt><rp>)</rp></ruby>", 22); j+=22;
                }
#ifdef COLOURED
                if (kd_colour!=0)
                {
                    memcpy(&p_out_str[j], "</font>", 7); j+=7;
                }
#endif
                continue;
            }
        }

        /* ɂȂ΂̂܂ */
        if (isKANJIb(p_inp_str[i]))
        {
            memcpy(&p_out_str[j], &p_inp_str[i], 2);
            i+=2;
            j+=2;
        }
        else
        {
            p_out_str[j] = p_inp_str[i];
            i++;
            j++;
        }
    }
    return(j);
}

/* TEXTϊ */
int convert_text(mchar p_out_str[], mchar p_inp_str[], int p_inp_len)
{
    int     i, j;
    ST_WORD *w_word;

    for(i=0, j=0; i<p_inp_len; )
    {
        /* ɂΕϊ */
        w_word = getword(kd_dict, &p_inp_str[i]);
        if (w_word!=NULL)
        {
            memcpy(&p_out_str[j], w_word->out_str, w_word->out_len);
            i+=w_word->inp_len;
            j+=w_word->out_len;
            continue;
        }

        /* ɂȂ΂̂܂ */
        if (isKANJIb(p_inp_str[i]))
        {
            memcpy(&p_out_str[j], &p_inp_str[i], 2);
            i+=2;
            j+=2;
        }
        else
        {
            p_out_str[j] = p_inp_str[i];
            i++;
            j++;
        }
    }
    return(j);
}

/* ̎擾 */
ST_WORD *getword(ST_DICT *p_dict, mchar p_str[])
{
    int     i;

    int     w_pos;
    int     w_len, w_cmp;
    int     w_from, w_to;
    int     w_start, w_stop;
    ST_WORD *w_word_tbl=p_dict->word_tbl;

    w_from = p_dict->word_idx[p_str[0]  ];
    w_to   = p_dict->word_idx[p_str[0]+1]-1;

    /* ɌȂ */
    if (w_from>w_to) return(NULL);

    /* ͈͂̍i荞(start) */
    w_len   = p_dict->word_len[ p_str[0] ];
    w_start = -1;
    w_stop  = w_to;
    for(;;)
    {
        if (w_from>w_to) break;

        w_pos = (w_from+w_to)>>1;
        w_cmp = memcmp(p_str, w_word_tbl[w_pos].inp_str, w_len);
        if (w_cmp<0)
        {
            w_to   = w_pos - 1;
            w_stop = w_to;
        }
        else if (w_cmp>0)
        {
            w_from = w_pos + 1;
        }
        else /* if (w_cmp==0) */
        {
            w_start = w_pos;
            w_to    = w_pos - 1;
        }
    }
    if (w_start==-1)
    {
        return(NULL);
    }

    /* Xɍi荞߂Ȃ݂ */
    if (w_word_tbl[w_start].inp_len>w_len)
    {
        if (isKANJIb(w_word_tbl[w_start].inp_str[w_len]))
        {
            w_len+=2;
        }
        else
        {
            w_len++;
        }
    }

    /* ͈͂̍i荞(stop) */
    w_from = w_start;
    w_to   = w_stop;
    w_stop = -1;
    for(;;)
    {
        if (w_from>w_to) break;

        w_pos = (w_from+w_to)>>1;
        w_cmp = memcmp(p_str, w_word_tbl[w_pos].inp_str, w_len);
        if (w_cmp<0)
        {
            w_to = w_pos - 1;
        }
        /* else if (w_cmp>0)
        {
            w_from  = w_pos + 1;
            w_start = w_from;
        } */
        else /* if (w_cmp==0) */
        {
            w_stop = w_pos;
            w_from = w_pos + 1;
        }
    }
    if (w_stop==-1)
    {
        return(NULL);
    }

    /* ŒvT */
    for(i=w_stop; i>=w_start; i-=w_word_tbl[i].cnt)
    {
        /*  */
        if (p_str[w_word_tbl[i].tail_pos]==w_word_tbl[i].tail_byte
        &&  memcmp(p_str, w_word_tbl[i].inp_str, w_word_tbl[i].inp_len)==0)
        {
            int     w_cnt, w_rand;
            w_cnt = w_word_tbl[i].cnt;
            if (w_cnt==1)
            {
                return(&w_word_tbl[i]);
            }
            else
            {
#ifdef RAND
                w_rand = rand () % w_cnt;
#else
                w_rand = random () % w_cnt;
#endif
                return(&w_word_tbl[i - w_rand]);
            }
        }
    }

    /* Ȃ */
    return(NULL);
}
